From 4c5c74f52c230e68530ef63ed68c9269b7482ddd Mon Sep 17 00:00:00 2001
From: Chen Qun <kuhn.chenqun@huawei.com>
Date: Thu, 2 Apr 2020 18:21:09 +0800
Subject: [PATCH 28/77] libvirt_hugepage: recalculate the number of static
 hugepage

The hugepage_size maybe 2M\512M\1024M for different os.
Add hugepage count for different hugepage_size.

Signed-off-by: Chen Qun <kuhn.chenqun@huawei.com>
---
 libvirt/tests/src/libvirt_hugepage.py | 12 ++++++++++--
 1 file changed, 10 insertions(+), 2 deletions(-)

diff --git a/libvirt/tests/src/libvirt_hugepage.py b/libvirt/tests/src/libvirt_hugepage.py
index 55ff7ab6..d64d6799 100644
--- a/libvirt/tests/src/libvirt_hugepage.py
+++ b/libvirt/tests/src/libvirt_hugepage.py
@@ -42,7 +42,6 @@ def prepare_c_file():
         output.writelines(outputlines)
     return "/tmp/test.c"
 
-
 def run(test, params, env):
     """
     Test steps:
@@ -54,9 +53,18 @@ def run(test, params, env):
     5) Check the hugepage memory usage.
     6) Clean up
     """
+
+    hugepage_size = utils_memory.get_huge_page_size()
+    logging.debug("System setting for large memory page size: %s",
+                      hugepage_size)
+    if hugepage_size > 2048:
+        shp_num_tmp = int(params.get("static_hugepage_num", 1024))
+        shp_num = int(shp_num_tmp / (hugepage_size / 2048))
+    else:
+        shp_num = int(params.get("static_hugepage_num", 1024))
+
     test_type = params.get("test_type", 'normal')
     tlbfs_enable = 'yes' == params.get("hugetlbfs_enable", 'no')
-    shp_num = int(params.get("static_hugepage_num", 1024))
     thp_enable = 'yes' == params.get("trans_hugepage_enable", 'no')
     mb_enable = 'yes' == params.get("mb_enable", 'yes')
     delay = int(params.get("delay_time", 10))
-- 
2.23.0

